<html>
<head>
<title>OGRE: OgreRenderQueue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRenderQueue.h</h1><a href="OgreRenderQueue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RenderQueue_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueue_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00043"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00">00043</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00" title="Enumeration of queue groups, by which the application may group queued renderables...">RenderQueueGroupID</a>
<a name="l00044"></a>00044     {
<a name="l00046"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c006f63169671858ecbaf90d237f5726cd4">00046</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c006f63169671858ecbaf90d237f5726cd4" title="Use this queue for objects which must be rendered first e.g. backgrounds.">RENDER_QUEUE_BACKGROUND</a> = 0,
<a name="l00048"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0085a7c54f44b9ac82523d80d19b6b2394">00048</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0085a7c54f44b9ac82523d80d19b6b2394" title="First queue (after backgrounds), used for skyboxes if rendered first.">RENDER_QUEUE_SKIES_EARLY</a> = 5,
<a name="l00049"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0082534671938c174a7d681d89083ef7db">00049</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0082534671938c174a7d681d89083ef7db">RENDER_QUEUE_1</a> = 10,
<a name="l00050"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0053b5d66a0512dfd2c311d7cc66b20381">00050</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0053b5d66a0512dfd2c311d7cc66b20381">RENDER_QUEUE_2</a> = 20,
<a name="l00051"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00de11af91b1f43096ff932b9c3843e5e4">00051</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00de11af91b1f43096ff932b9c3843e5e4">RENDER_QUEUE_WORLD_GEOMETRY_1</a> = 25,
<a name="l00052"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0072b7acba73734142cfa10e9cc75962c9">00052</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0072b7acba73734142cfa10e9cc75962c9">RENDER_QUEUE_3</a> = 30,
<a name="l00053"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c009e2ea42071d435e220510e556cd7406c">00053</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c009e2ea42071d435e220510e556cd7406c">RENDER_QUEUE_4</a> = 40,
<a name="l00055"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00f9d31cc0cad8ce9890b4af5f9014f5be">00055</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00f9d31cc0cad8ce9890b4af5f9014f5be" title="The default render queue.">RENDER_QUEUE_MAIN</a> = 50,
<a name="l00056"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00531fdb018ca4d5ff2ba7a97fba949bbe">00056</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00531fdb018ca4d5ff2ba7a97fba949bbe">RENDER_QUEUE_6</a> = 60,
<a name="l00057"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00bc64da9d300b2d65a19e5fc0bfa05d58">00057</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00bc64da9d300b2d65a19e5fc0bfa05d58">RENDER_QUEUE_7</a> = 70,
<a name="l00058"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00256a799730f10076007fd0411e033b1f">00058</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c00256a799730f10076007fd0411e033b1f">RENDER_QUEUE_WORLD_GEOMETRY_2</a> = 75,
<a name="l00059"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0031ac7ce7cf426c952976a3fdcc3e4e8e">00059</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0031ac7ce7cf426c952976a3fdcc3e4e8e">RENDER_QUEUE_8</a> = 80,
<a name="l00060"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c005c4ab4460dc0489bbc5ea049d8412d21">00060</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c005c4ab4460dc0489bbc5ea049d8412d21">RENDER_QUEUE_9</a> = 90,
<a name="l00062"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0053468f34583f3a469cc8ca2f444fb6ff">00062</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0053468f34583f3a469cc8ca2f444fb6ff" title="Penultimate queue(before overlays), used for skyboxes if rendered last.">RENDER_QUEUE_SKIES_LATE</a> = 95,
<a name="l00064"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0051f548bb157ad908542478155f7d807b">00064</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c0051f548bb157ad908542478155f7d807b" title="Use this queue for objects which must be rendered last e.g. overlays.">RENDER_QUEUE_OVERLAY</a> = 100, 
<a name="l00066"></a><a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c002d1e261d9e3298b1cb7272b392f550b1">00066</a>         <a class="code" href="namespaceOgre.html#d08013a341ff0ef07c39fa3502bf6c002d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&amp;#39;t exceed this.">RENDER_QUEUE_MAX</a> = 105
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="OgreRenderQueue_8h.html#f7eb718b406b59b1762c3e37b90212b3">00069</a> <span class="preprocessor">    #define OGRE_RENDERABLE_DEFAULT_PRIORITY  100</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00082"></a><a class="code" href="classOgre_1_1RenderQueue.html">00082</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>
<a name="l00083"></a>00083     {
<a name="l00084"></a>00084     <span class="keyword">public</span>:
<a name="l00085"></a><a class="code" href="classOgre_1_1RenderQueue.html#13888e99247750aefc38fee2e106c2b9">00085</a>         <span class="keyword">typedef</span> std::map&lt; uint8, RenderQueueGroup* &gt; RenderQueueGroupMap;
<a name="l00087"></a><a class="code" href="classOgre_1_1RenderQueue.html#4cf42f3f073ba37a87a555e37143ed1e">00087</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;RenderQueueGroupMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">QueueGroupIterator</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html">00093</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095         <span class="keyword">public</span>:
<a name="l00096"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#0820da08b1cfaa649e9795e005161d98">00096</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>() {}
<a name="l00097"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#a1cf2797eb257b192b5a7f4d7927bce6">00097</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>() {}
<a name="l00098"></a>00098 
<a name="l00115"></a>00115             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> renderableQueued(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupID, 
<a name="l00116"></a>00116                 <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> priority, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>** ppTech) = 0;
<a name="l00117"></a>00117         };
<a name="l00118"></a>00118     <span class="keyword">protected</span>:
<a name="l00119"></a><a class="code" href="classOgre_1_1RenderQueue.html#af91a53059c0a0f61c07d3a0753a3bfe">00119</a>         RenderQueueGroupMap mGroups;
<a name="l00121"></a><a class="code" href="classOgre_1_1RenderQueue.html#7166e043e0913cb1e08e4737befce3f6">00121</a>         <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> mDefaultQueueGroup;
<a name="l00123"></a><a class="code" href="classOgre_1_1RenderQueue.html#f1e1472401b4e1d24676e60d41b4705d">00123</a>         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> mDefaultRenderablePriority;
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classOgre_1_1RenderQueue.html#f5adba44e7d9c936efcb35d389d5bb58">00125</a>         <span class="keywordtype">bool</span> mSplitPassesByLightingType;
<a name="l00126"></a><a class="code" href="classOgre_1_1RenderQueue.html#66986fa9c851664d568e3dbb5a2d40cb">00126</a>         <span class="keywordtype">bool</span> mSplitNoShadowPasses;
<a name="l00127"></a><a class="code" href="classOgre_1_1RenderQueue.html#bfb15a31918778ed0e0c74aacf3358f6">00127</a>         <span class="keywordtype">bool</span> mShadowCastersCannotBeReceivers;
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1RenderQueue.html#dd07814ff649c3a7a914fa3961a83a3d">00129</a>         <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* mRenderableListener;
<a name="l00130"></a>00130     <span class="keyword">public</span>:
<a name="l00131"></a>00131         <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>();
<a name="l00132"></a>00132         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>();
<a name="l00133"></a>00133 
<a name="l00138"></a>00138         <span class="keywordtype">void</span> clear(<span class="keywordtype">bool</span> destroyPassMaps = <span class="keyword">false</span>);
<a name="l00139"></a>00139 
<a name="l00145"></a>00145         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>* getQueueGroup(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> qid);
<a name="l00146"></a>00146 
<a name="l00169"></a>00169         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupID, <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> priority);
<a name="l00170"></a>00170 
<a name="l00188"></a>00188         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupId);
<a name="l00189"></a>00189 
<a name="l00202"></a>00202         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend);
<a name="l00203"></a>00203         
<a name="l00207"></a>00207         <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getDefaultQueueGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00208"></a>00208 
<a name="l00213"></a>00213         <span class="keywordtype">void</span> setDefaultRenderablePriority(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> priority);
<a name="l00214"></a>00214 
<a name="l00218"></a>00218         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> getDefaultRenderablePriority(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00219"></a>00219 
<a name="l00223"></a>00223         <span class="keywordtype">void</span> setDefaultQueueGroup(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> grp);
<a name="l00224"></a>00224         
<a name="l00226"></a>00226         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">QueueGroupIterator</a> _getQueueGroupIterator(<span class="keywordtype">void</span>);
<a name="l00230"></a>00230         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split);
<a name="l00235"></a>00235         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split);
<a name="l00239"></a>00239         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind);
<a name="l00240"></a>00240 
<a name="l00246"></a><a class="code" href="classOgre_1_1RenderQueue.html#4830aa759ae0619a637dc979f8f0d581">00246</a>         <span class="keywordtype">void</span> setRenderableListener(<a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* listener)
<a name="l00247"></a>00247         { mRenderableListener = listener; }
<a name="l00248"></a>00248 
<a name="l00249"></a><a class="code" href="classOgre_1_1RenderQueue.html#0833e163d52c2fffef84dfe81af1606a">00249</a>         <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* getRenderableListener(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00250"></a>00250 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mRenderableListener; }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252     };
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
